diff --git a/pki/base/util/src/netscape/security/x509/OIDMap.java b/pki/base/util/src/netscape/security/x509/OIDMap.java
index 082ecc4fd31630dca2e471ff3017917083c2a2f7..97e8d26e080ffbbc886012549bd42f151026832f 100644
--- a/pki/base/util/src/netscape/security/x509/OIDMap.java
+++ b/pki/base/util/src/netscape/security/x509/OIDMap.java
@@ -21,8 +21,8 @@ import java.io.File;
 import java.io.FileInputStream;
 import java.io.IOException;
 import java.security.cert.CertificateException;
-import java.util.Enumeration;
 import java.util.Hashtable;
+import java.util.Iterator;
 import java.util.Properties;
 
 import netscape.security.util.ObjectIdentifier;
@@ -58,42 +58,42 @@ public class OIDMap {
                                  X509CertInfo.NAME + "." +
                                  X509CertInfo.EXTENSIONS;
     private static final String AUTH_KEY_IDENTIFIER = ROOT + "." +
-                                          AuthorityKeyIdentifierExtension.NAME;
+                                          AuthorityKeyIdentifierExtension.class.getSimpleName();
     private static final String SUB_KEY_IDENTIFIER  = ROOT + "." +
-                                          SubjectKeyIdentifierExtension.NAME;
+                                          SubjectKeyIdentifierExtension.class.getSimpleName();
     private static final String KEY_USAGE           = ROOT + "." +
-                                          KeyUsageExtension.NAME;
+                                          KeyUsageExtension.class.getSimpleName();
     private static final String PRIVATE_KEY_USAGE   = ROOT + "." +
-                                          PrivateKeyUsageExtension.NAME;
+                                          PrivateKeyUsageExtension.class.getSimpleName();
     private static final String POLICY_MAPPINGS     = ROOT + "." +
-                                          PolicyMappingsExtension.NAME;
+                                          PolicyMappingsExtension.class.getSimpleName();
     private static final String SUB_ALT_NAME        = ROOT + "." +
-                                          SubjectAlternativeNameExtension.NAME;
+                                          SubjectAlternativeNameExtension.class.getSimpleName();
     private static final String ISSUER_ALT_NAME     = ROOT + "." +
-                                          IssuerAlternativeNameExtension.NAME;
+                                          IssuerAlternativeNameExtension.class.getSimpleName();
     private static final String BASIC_CONSTRAINTS   = ROOT + "." +
-                                          BasicConstraintsExtension.NAME;
+                                          BasicConstraintsExtension.class.getSimpleName();
     private static final String NAME_CONSTRAINTS    = ROOT + "." +
-                                          NameConstraintsExtension.NAME;
+                                          NameConstraintsExtension.class.getSimpleName();
     private static final String POLICY_CONSTRAINTS  = ROOT + "." +
-                                          PolicyConstraintsExtension.NAME;
+                                          PolicyConstraintsExtension.class.getSimpleName();
     private static final String CERT_POLICIES  = //ROOT + "." +
-                                          CertificatePoliciesExtension.NAME;
+                                          CertificatePoliciesExtension.class.getSimpleName();
     private static final String SUBJ_DIR_ATTR  = //ROOT + "." +
-                                          SubjectDirAttributesExtension.NAME;
+                                          SubjectDirAttributesExtension.class.getSimpleName();
     public static final String EXT_KEY_USAGE_NAME = "ExtendedKeyUsageExtension";
     public static final String EXT_INHIBIT_ANY_POLICY_NAME = "InhibitAnyPolicyExtension";
     private static final String EXT_KEY_USAGE = //ROOT + "." +
                                           EXT_KEY_USAGE_NAME;
 
     private static final String CRL_NUMBER  = ROOT + "." +
-                                          CRLNumberExtension.NAME;
+                                          CRLNumberExtension.class.getSimpleName();
     private static final String CRL_REASON  = ROOT + "." +
-                                          CRLReasonExtension.NAME;
+                                          CRLReasonExtension.class.getSimpleName();
 
-    private static final Hashtable oid2Name = new Hashtable();
-    private static final Hashtable name2OID = new Hashtable();
-    private static final Hashtable name2Class = new Hashtable();
+    private static final Hashtable<ObjectIdentifier, String> oid2Name = new Hashtable<ObjectIdentifier, String>();
+    private static final Hashtable<String, ObjectIdentifier> name2OID = new Hashtable<String, ObjectIdentifier>();
+    private static final Hashtable<String, String> name2Class = new Hashtable<String, String>();
 
     // Initialize recognized extensions from EXTENSIONS_{OIDS/CLASSES} files
     static {
@@ -174,9 +174,9 @@ public class OIDMap {
             }
         }
 
-        Enumeration names = props.propertyNames();
-        while (names.hasMoreElements()) {
-            String name = (String)names.nextElement();
+        Iterator<String> names = props.stringPropertyNames().iterator();
+        while (names.hasNext()) {
+            String name = names.next();
             String oidName = props.getProperty(name);
             ObjectIdentifier oid = new ObjectIdentifier(oidName);
 
@@ -201,9 +201,9 @@ public class OIDMap {
             }
         }
 
-        Enumeration names = props.propertyNames();
-        while (names.hasMoreElements()) {
-            String name = (String)names.nextElement();
+        Iterator<String> names = props.stringPropertyNames().iterator();
+        while (names.hasNext()) {
+            String name = names.next();
             String className = props.getProperty(name);
 
             name2Class.put(name, className);
@@ -265,12 +265,12 @@ public class OIDMap {
      * @param name the user friendly name.
      * @exception CertificateException if class cannot be instantiated.
      */
-    public static Class getClass(String name) throws CertificateException {
+    public static Class<?> getClass(String name) throws CertificateException {
         String className = (String)name2Class.get(name);
         if (className == null)
             return null;
         try {
-            Class extClass = Class.forName(className);
+            Class<?> extClass = Class.forName(className);
 	    return (extClass);
 	} catch (Exception e) {
 	  throw new CertificateException("Error instantiating class for "
@@ -284,7 +284,7 @@ public class OIDMap {
      * @param oid the name of the object identifier to be returned.
      * @exception CertificateException if class cannot be instatiated.
      */
-    public static Class getClass(ObjectIdentifier oid)
+    public static Class<?> getClass(ObjectIdentifier oid)
     throws CertificateException {
         String name = getName(oid);
         if (name == null)
@@ -293,7 +293,7 @@ public class OIDMap {
         if (className == null)
             return null;
         try {
-            Class extClass = Class.forName(className);
+            Class<?> extClass = Class.forName(className);
 	    return (extClass);
 	} catch (Exception e) {
 	    throw new CertificateException("Error instantiating class for "
diff --git a/pki/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java b/pki/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
index 681d449b2845b8766e29a6b6246d88e6a9dac6fd..39e7fbfb92f286d65b5dd773f3229522381a4294 100644
--- a/pki/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
@@ -67,7 +67,6 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "PolicyConstraints";
     public static final String REQUIRE = "require";
     public static final String INHIBIT = "inhibit";
 
@@ -275,7 +274,7 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(REQUIRE);
         elements.addElement(INHIBIT);
@@ -283,12 +282,6 @@ implements CertAttrSet {
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 
     /**
      * returns the requireExplicitMapping parameter.
diff --git a/pki/base/util/src/netscape/security/x509/PolicyMappingsExtension.java b/pki/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
index 90dd5267dca72364159944447c675b34632cfedf..c31acf92b40d694669d0c9903c1610e65577faec 100644
--- a/pki/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
@@ -61,11 +61,10 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "PolicyMappings";
     public static final String MAP = "map";
 
     // Private data members
-    private Vector maps = null;
+    private Vector<CertificatePolicyMap> maps = null;
 
     // Encode this extension value
     private void encodeThis() throws IOException {
@@ -84,7 +83,7 @@ implements CertAttrSet {
      *
      * @param maps the Vector of CertificatePolicyMap.
      */
-    public PolicyMappingsExtension(Vector map) throws IOException {
+    public PolicyMappingsExtension(Vector<CertificatePolicyMap> map) throws IOException {
 		init(false, map);
     }
 
@@ -93,7 +92,7 @@ implements CertAttrSet {
      *
      * @param maps the Vector of CertificatePolicyMap.
      */
-    public PolicyMappingsExtension(boolean critical, Vector map) 
+    public PolicyMappingsExtension(boolean critical, Vector<CertificatePolicyMap> map) 
 	throws IOException {
 		init(critical, map);
 	}
@@ -101,7 +100,7 @@ implements CertAttrSet {
 	/**
 	 * init policy with criticality and map.
 	 */
-    private void init(boolean critical, Vector map) throws IOException {
+    private void init(boolean critical, Vector<CertificatePolicyMap> map) throws IOException {
         this.maps = map;
         this.extensionId = PKIXExtensions.PolicyMappings_Id;
         this.critical = critical;
@@ -114,7 +113,7 @@ implements CertAttrSet {
     public PolicyMappingsExtension() {
         extensionId = PKIXExtensions.PolicyMappings_Id;
         critical = false;
-        maps = new Vector(1,1);
+        maps = new Vector<CertificatePolicyMap>(1,1);
     }
 
     /**
@@ -140,7 +139,7 @@ implements CertAttrSet {
             throw new IOException("Invalid encoding for " +
                                   "PolicyMappingsExtension.");
         }
-        maps = new Vector(1, 1);
+        maps = new Vector<CertificatePolicyMap>(1, 1);
         while (val.data.available() != 0) {
             DerValue seq = val.data.getDerValue();
             CertificatePolicyMap map = new CertificatePolicyMap(seq);
@@ -189,14 +188,15 @@ implements CertAttrSet {
     /**
      * Set the attribute value.
      */
-    public void set(String name, Object obj) throws IOException {
+	@SuppressWarnings("unchecked")
+	public void set(String name, Object obj) throws IOException {
 	clearValue();
 	if (name.equalsIgnoreCase(MAP)) {
 	    if (!(obj instanceof Vector)) {
 	      throw new IOException("Attribute value should be of" +
                                     " type Vector.");
 	    }
-	    maps = (Vector)obj;
+	    maps = (Vector<CertificatePolicyMap>)obj;
 	} else {
 	  throw new IOException("Attribute name not recognized by " + 
 			"CertAttrSet:PolicyMappingsExtension.");
@@ -231,24 +231,18 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(MAP);
 
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 
     /**
      * Returns an enumeration of the mappings in the extension.
      */
-    public Enumeration getMappings() {
+    public Enumeration<CertificatePolicyMap> getMappings() {
 	if (maps == null) 
 		return null;
 	return maps.elements();
diff --git a/pki/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java b/pki/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
index 30944495d672e11f508102d910de84512e8150dd..98a7a4d3c020cae647f2bb146fed37a86f1f1bde 100644
--- a/pki/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
+++ b/pki/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
@@ -70,7 +70,6 @@ implements CertAttrSet {
     /**
      * Sub attributes name for this CertAttrSet.
      */
-    public static final String NAME = "PrivateKeyUsage";
     public static final String NOT_BEFORE = "not_before";
     public static final String NOT_AFTER = "not_after";
 
@@ -321,7 +320,7 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
 	elements.addElement(NOT_BEFORE);
 	elements.addElement(NOT_AFTER);
@@ -329,10 +328,5 @@ implements CertAttrSet {
 	return(elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName() {
-      return(NAME);
-    }
+    
 }
